<#-- utilities for SPC report (RTF and PDF) -->
<#assign locale = "en">

<#assign param = "paramPhrase"/>

<#assign parameterisedPhraseNotRelevant = true />


<#--
<#assign spcFamilyContext = 
  "{
    \"spcProductPublicationInputs\": [
    {
      \"productDocName\": \"MyProduct1\",
      \"authorizationNumber\": \"DE-1234567-0001\",
      \"metaSpcSuffix\": \"1-1\"
    },
    {
      \"productDocName\": \"MyProduct2\",
      \"authorizationNumber\": \"DE-1234567-0002\",
      \"metaSpcSuffix\": \"1-2\"
    },
    {
      \"productDocName\": \"MyProduct\",
      \"authorizationNumber\": \"DE-1234567-0003\",
      \"metaSpcSuffix\": \"1-3\"
    }
  ],
  \"metaSpcPublicationInput\" : [
	{
		\"metaSpcDocName\": \"MyMetaSpc1\",
		\"metaSpcSuffix\": \"1-1\"
	},
	{
		\"metaSpcDocName\": \"MyMetaSpc2\",
		\"metaSpcSuffix\": \"1-2\"
	},
	{
		\"metaSpcDocName\": \"MyMetaSpc3\",
		\"metaSpcSuffix\": \"1-3\"
	}
  ],
  \"authorisationNumber\": \"BE-0037975-0000\",
  \"authorisationHolderName\":\"Company B\",
  \"authorisationHolderAddress\":{
    \"street\":\"gyzi nikolaou\",
    \"postalCode\":\"1234\",
    \"city\":\"athens\",
    \"country\":{
        \"code\":\"GR\"}
   },
   \"validityStartDateStandardPhrase\":\"Please insert the date of entry into force of this Implementing Regulation\",
   \"validityEndDateStandardPhrase\":\"Please insert the validity end date of this Implementing Regulation\"
}"
/>
-->
<#-- initiate the main variables -->
<@com.initializeMainVariables/>

<#function convertArrayToMap myArray keyProperty valueProperty>
  
  <#local map = {}>

  <#list myArray as item>
    <#local map = map + {item[keyProperty]: item[valueProperty]} /> 
  </#list>
      
  <#return map>
</#function>

<#function getR4BPInjection item id="">
  <#if item?has_content && id=="authorisationNumbers">
    <#return productAuthorizationNumbersMap[item]!"" />
  <#elseif item?has_content && id=="metaSPCsuffices">
    <#return metaSPCsuficesMap[item]!"" />
  <#else>
    <#return "">
  </#if>
</#function>

<#-- if doc type or subtype change, only change it here -->
<#assign mainMixtureCompositionList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_RECORD", "MixtureComposition") />
<#assign mainMixtureCompositionSummaryList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_SUMMARY", "ProductSummaryComposition") />
<#assign supplierList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_RECORD", "Suppliers") />	
<#assign protectionMeasuresList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_RECORD", "ProtectionMeasures") />	
<#assign usesList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_RECORD", "BioIntendedUsesExposure") />	
<#assign ghsList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_RECORD", "Ghs") />	
<#assign summaryAndEvaluationList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_SUMMARY", "BioSummaryEvaluation") />	
<#assign otherInformationList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_RECORD", "OtherInformationSPC") />	
<#assign sitesList = iuclid.getSectionDocumentsForParentKey(_subject.documentKey, "FLEXIBLE_RECORD", "Sites") />	

    <#assign tableID = {
    "table_id_1":"Trade name(s) of the product",
    "table_id_2":"Qualitative and quantitative information on the composition of the product",    
    "table_id_3":"Authorisation holder",
    "table_id_4":"Hazard and precautionary statements",
    "table_id_5":"Use description",
    "table_id_6":"Manufacturer(s) of the product",
    "table_id_7":"Manufacturer(s) of the active substance(s)",
    "table_id_8":"Formulation types product",
    "table_id_1_family":"Family name",   
    "table_id_2_family":"Product type",
    "table_id_3_family":"Qualitative and quantitative information on the composition of the family summary", 
    "table_id_4_family":"Formulation types summary",

    "table_id_5_family":"Qualitative and quantitative information on the composition of the meta spc",
    "table_id_6_family":"Formulation types meta spc",
    "table_id_7_family":"Meta SPC Hazard and precautionary statements",
    "table_id_8_family":"Meta SPC Use description",
    "table_id_9_family":"Meta SPC Other information",
    "table_id_10_family":"Meta SPC Product composition",
    "table_id_11_family":"Meta SPC Product composition additional",
    
    "table_id_12_family":"Meta SPC identifier",
    "table_id_13_family":"Suffix to the authorisation number",
    "table_id_14_family":"Product type(s)"
  }/>

  <#-------------------------------------------------------
  ---------------------------------------------------------
  *hashmap pairing source phrase code to custom phrase code
  ---------------------------------------------------------
  -------------------------------------------------------->

<#global standardToParameterisedPhraseCode = {
	"7341":"131557",
  "7369":"131558",
  "7342":"131559",
  "7348":"131560",
  "7352":"131561",
  "7354":"131562",
  "7355":"131563",
  "7358":"131564",
  "7363":"131565",
  "7421":"131566",
  "7422":"131567",
  "7426":"131568",
  "7428":"131569",
  "8413":"131570",
  "7434":"131571",
  "7380":"131572",
  "7381":"131573",
  "7382":"131574",
  "7383":"131575",
  "7384":"131576",
  "7385":"131577",
  "7386":"131578",
  "7387":"131579",
  "7436":"131580",
  "7437":"131581",
  "61837":"131582",
  "7439":"131583",
  "7440":"131584",
  "7403":"131585",
  "7442":"131586",
  "61841":"131587",
  "7416":"131588",
  "7446":"131589",
  "7451":"131590",
  "7454":"131591",
  "7456":"131592",
  "7465":"131593",
  "65670":"131594",
  "7314":"131547",
  "7315":"131548",
  "7316":"131549",
  "7317":"131550",
  "7318":"131551",
  "7319":"131552",
  "7321":"131553",
  "7322":"131554",
  "7323":"131555",
  "7324":"131556",
  "8004":"131595",
  "8022": "138382",
  "137191":"137191",
  "137192":"137192",
  "137196":"137196",
  "137197":"137197",
  "137198":"137198",
  "137205":"137205",
  "137208":"137208",
  "137209":"137209",
  "137213":"137213",
  "137216":"137216",
  "137217":"137217",
  "137220":"137220",
  "137222":"137222",
  "137224":"137224",
  "137226":"137226",
  "137227":"137227",
  "137228":"137228",
  "137230":"137230",
  "137235":"137235",
  "137236":"137236",
  "137239":"137239",
  "137240":"137240",
  "137241":"137241",
  "137242":"137242",
  "137243":"137243",
  "137244":"137244",
  "137245":"137245",
  "137248":"137248",
  "137249":"137249",
  "137251":"137251",
  "137252":"137252",
  "137255":"137255",
  "137256":"137256",
  "137257":"137257",
  "137259":"137259",
  "137260":"137260",
  "137261":"137261",
  "137262":"137262",
  "137265":"137265",
  "137266":"137266",
  "137273":"137273",
  "137276":"137276",
  "137277":"137277",
  "137280":"137280",
  "137283":"137283",
  "137284":"137284",
  "137289":"137289",
  "137304":"137304",
  "137307":"137307",
  "137308":"137308",
  "137309":"137309",
  "137315":"137315",
  "137318":"137318",
  "137319":"137319",
  "137320":"137320",
  "137321":"137321",
  "137324":"137324",
  "137325":"137325",
  "137328":"137328",
  "137331":"137331",
  "137332":"137332",
  "137336":"137336",
  "137338":"137338",
  "137341":"137341",
  "137345":"137345",
  "137352":"137352",
  "137356":"137356",
  "137358":"137358",
  "137364":"137364",
  "137369":"137369",
  "137373":"137373",
  "137379":"137379",
  "137380":"137380",
  "137382":"137382",
  "137384":"137384",
  "137385":"137385",
  "137388":"137388",
  "137389":"137389",
  "137392":"137392",
  "137397":"137397",
  "137399":"137399",
  "137401":"137401",
  "137406":"137406",
  "137407":"137407",
  "137410":"137410",
  "137412":"137412",
  "137413":"137413",
  "137415":"137415",
  "137416":"137416",
  "137418":"137418",
  "137419":"137419",
  "137421":"137421",
  "137423":"137423",
  "137424":"137424",
  "137425":"137425",
  "137427":"137427",
  "137428":"137428",
  "137429":"137429",
  "137435":"137435",
  "137437":"137437",
  "137440":"137440"
  } />
   
<#-- This is the macro to use in prod, when all macros point here -->
<#-- This defines a macro called staticTextTest and a function called getStaticText that are used to retrieve static text values based on a given key and language locale -->
<#-- The staticTextTest macro is called with a parameter textKey that corresponds to a specific text value in the tocStaticText map defined later in the code. This macro also includes an optional metaSPCcounter parameter that can be used to provide additional information -->
<#macro staticText textKey metaSPCcounter="">
<#compress>
	<#-- a globally defined language locale comes from the Dossier header -->
	${getStaticText(textKey, languageLocale)} ${metaSPCcounter}
 </#compress>
</#macro>

<#-- The getStaticText function takes two parameters: textKey and languageLocale. 
It first checks if the language locale is provided and exists in the tocStaticText map. 
If so, it retrieves the text resources associated with that locale. If not, it defaults to the English locale. 
It then retrieves the text associated with the given textKey in the text resources, or an empty string if it does not exist. The function returns the text-->
<#function getStaticText textKey languageLocale>
<#-- Check if bundleLocalizationPrefix is null or empty, and use "properties/" string as default -->
    <#assign bundleName = (bundleLocalizationPrefix!"properties/" ) + 'localizations' />

    <#if languageLocale?has_content && textKey?has_content>
        <#local textResources = iuclid.text('${textKey}', '${languageLocale}', bundleName) />
    <#else>
        <#local textResources = iuclid.text('${textKey}', 'en', bundleName) />
    </#if>
    <#return textResources />
</#function>

<#-------------------------------------------------->
<#-- Common sections in single and family reports -->
<#-------------------------------------------------->

<#macro manufacturerOfTheProduct>

<#--
List sites
List site refs
List legal refs
If content in legal refs, output legal ref info and site ref info
If not content in legal refs, List legal refs and only output legal ref info
-->

  <#assign linkedLe = []/>
  <#assign supplierKey = [] />
  <#assign mysupplierskey = [] />
  <#assign mysite = [] />  

  <#list supplierList as suppliers>
  <#if suppliers?has_content>
  <#assign supplierKey = supplierKey + [suppliers]/>

    <#local linkedLe = iuclid.getDocumentForKey(suppliers.ManufacturerImportForm.LegalEntity)/>

    <#if linkedLe?has_content>
    <#assign mysupplierskey = mysupplierskey + [linkedLe]/>      
      <@macroForPopulatingLegalEntity linkedLe "${tableID.table_id_6}"/>
      <@verticalHeaderTable linkedLe isMoreThanOneDoc(supplierKey) _subject linkedLe "headerPlaceholder" "${part1Table1Cell1}" "${part1Table1Cell2}" "${part1Table1Cell3}" "headerPlaceholder" "headerPlaceholder" "headerPlaceholder" "headerPlaceholder" "twoColTable" "${tableID.table_id_6}"/>   
    </#if>
  </#if>
  </#list>
</#macro>

  <#-- active substance manufacturer and location --------------------------------->
  <#-- iterate through active substances of both summary and product -------------->
  <#-- fetch manufacturer info (supplier) ready for checking location (LE match) -->
  <#-- each active substance names is also fetched -------------------------------->

<#macro suppliersInformation activeSubstanceList compositionType="">

<#assign activeSubstanceSummaryKey = [] />
<#assign activeSubstanceSumSupplierList = [] />
<#assign activeSubstanceSumSitesList = [] />
<#assign activeSuppliers = [] />
<#assign activeSubstanceSitesList = [] />
<#assign sitesAS = [] />
<#assign activeSubstanceKey = []/>

<#assign activeSubstanceProductKey = [] />
<#assign activeSubstanceProductSupplierList = [] />
<#assign activeSubstanceProductSitesList = [] />
  
  <#if activeSubstanceList.hasElement("Name")>

      <#assign activeSubstanceKey = iuclid.getDocumentForKey(activeSubstanceList.Name)/>

      <#assign activeSubstanceSumSupplierList = iuclid.getSectionDocumentsForParentKey(activeSubstanceKey.documentKey, "FLEXIBLE_RECORD", "Suppliers") />
      <#assign activeSuppliers = activeSuppliers + [activeSubstanceSumSupplierList]/>
      
      <#assign activeSubstanceSumSitesList = iuclid.getSectionDocumentsForParentKey(activeSubstanceKey.documentKey, "FLEXIBLE_RECORD", "Sites") />
      <#list activeSubstanceSumSitesList as sitesAS>
        <#assign activeSubstanceSitesList = activeSubstanceSitesList + [sitesAS] />
      </#list>

  <#elseif activeSubstanceList.hasElement("Reference")>

      <#assign activeSubstanceKey = iuclid.getDocumentForKey(activeSubstanceList.Reference)/>  

      <#assign activeSubstanceSumSupplierList = iuclid.getSectionDocumentsForParentKey(activeSubstanceKey.documentKey, "FLEXIBLE_RECORD", "Suppliers") />
      <#assign activeSuppliers = activeSuppliers + [activeSubstanceSumSupplierList]/>
      
      <#assign activeSubstanceProductSitesList = iuclid.getSectionDocumentsForParentKey(activeSubstanceKey.documentKey, "FLEXIBLE_RECORD", "Sites") />
      <#list activeSubstanceProductSitesList as sitesAS>
        <#assign activeSubstanceSitesList = activeSubstanceSitesList + [sitesAS] />
      </#list>  
  </#if>
</#macro>

<#macro manufacturerOfTheActiveSubstanceSection meta="" documentTypes="">

<#assign arrayofActiveSubstanceCompositions = [] />
<#assign activeSubstanceReferenceSubstance = []/>
<#assign siteKey = [] />
<#assign supplierLists = []/>
  
  <!-- check which type of composition concerned, summary or product composition -->
  <#if documentTypes=="compositionSummary">  
    <#assign arrayofActiveSubstanceCompositions = getActiveSubstanceSummaryComponents(mainMixtureCompositionSummaryList) />
  <#elseif documentTypes=="compositionProduct">
    <#assign arrayofActiveSubstanceCompositions = getActiveSubstanceComponents(mainMixtureCompositionList) />
  </#if>

  <#if arrayofActiveSubstanceCompositions?has_content>
    <#list arrayofActiveSubstanceCompositions as activeSubstances>
      <#if activeSubstances?has_content>

        <@suppliersInformation activeSubstances/>
        <@substanceAndReferenceSubstanceIdentifiers activeSubstanceKey activeSubstances "manufacturersBlock"/> 

        <#if activeSubstanceSumSupplierList?has_content>
          <#list activeSubstanceSumSupplierList as mySuppliers>
            <#if mySuppliers?has_content>
            <#assign supplierReferenceKey = iuclid.getDocumentForKey(mySuppliers.ManufacturerImportForm.LegalEntity)/>
            <#assign siteKey = siteKey + [supplierReferenceKey]/>
              <#if supplierReferenceKey?has_content>
                <@macroForPopulatingLegalEntity supplierReferenceKey "${tableID.table_id_6}"/> 
                <@verticalHeaderTable activeSubstanceSitesList isMoreThanOneDoc(siteKey) refSubstanceNameInSubstance supplierReferenceKey "${part1Table1Cell4}" "${part1Table1Cell1}" "${part1Table1Cell2}" "${part1Table1Cell3}" "${part1Table1Cell4}" "headerPlaceholder" "headerPlaceholder" "headerPlaceholder" "twoColTable" "${tableID.table_id_7}"/>   
              </#if>         
            </#if>
          </#list>
        </#if>

      </#if>
    </#list>
  </#if>
</#macro>

<#macro arrayAS keys>
<#if keys.hasElement("Reference")>
<#assign activeSubstanceKey = iuclid.getDocumentForKey(keys.Reference)/>  
    <#if activeSubstanceKey?has_content && activeSubstanceKey.hasElement("ChemicalName")><@com.text activeSubstanceKey.ChemicalName/><#else></#if>
    <#if activeSubstanceKey?has_content && activeSubstanceKey.hasElement("ReferenceSubstanceName")><@com.text activeSubstanceKey.ReferenceSubstanceName/><#else></#if> 
</#if>        
</#macro>

<#macro arraySummaryAS summkeys>
<#if summkeys.hasElement("Name")>
<#assign activeSubstanceSummaryKey = iuclid.getDocumentForKey(summkeys.Name)/>
  <#if activeSubstanceSummaryKey?has_content && activeSubstanceSummaryKey.hasElement("ChemicalName")><@com.text activeSubstanceSummaryKey.ChemicalName/><#else></#if>
  <#if activeSubstanceSummaryKey?has_content && activeSubstanceSummaryKey.hasElement("ReferenceSubstanceName")><@com.text activeSubstanceSummaryKey.ReferenceSubstanceName/><#else></#if> 
</#if>
</#macro>

<#------------------------------->
<#-- Table of vertical headers -->
<#------------------------------->

<#macro verticalHeaderTable arraykeys isMoreThanOneDoc activeSubReferenceSubName repeatableBlock header1="" header2="" header3="" header4="" header5="" header6="" header7="" header8="" numberOfColumns="" id="">
<#compress>
<#-- table configuration -->
<informaltable frame="all">
    <#if numberOfColumns=="threeColTable">
      <tgroup cols='3' colsep='1' rowsep='1' frame='all'>			
      <colspec colnum="1" colname='col1' colwidth='2.7in'/>
      <colspec colnum="2" colname='col2' colwidth='0.8in'/>
      <colspec colnum="3" colname='col3' colwidth='2.7in'/>
      <spanspec spanname='bspan' namest="col1" nameend="col2" frame='sides'></spanspec>
    <#elseif numberOfColumns=="twoColTable">
      <tgroup cols='2' colsep='1' rowsep='1' frame='all'>    
      <colspec colname='col1' />
      <colspec colname='col2' />
    </#if>
    <#-- table body -->
    <tbody>

      <#if numberOfColumns=="twoColTable" && id=="Meta SPC identifier">   
        <row>  
          <entry>${header1}</entry>
            <entry>
            <#if repeatableBlock?has_content>
              <@com.text repeatableBlock.ProductSummaryComposition.ProductFamilyGroupName/>
            </#if>
           </entry> 
        </row>
      </#if>

      <#if numberOfColumns=="twoColTable" && id=="Suffix to the authorisation number"> 
      <#assign metaSPCdocName>${repeatableBlock.name}</#assign>
        <row>  
          <entry>${header1}</entry>
            <entry>
              <#if repeatableBlock?has_content && spcFamilyContext?has_content>
                ${getR4BPInjection(repeatableBlock.name, "metaSPCsuffices")}
              <#else>
                <!-- Provide an alternative output or handle the condition as needed -->
              </#if>
           </entry> 
        </row>  
      </#if>

       <#if numberOfColumns=="twoColTable" && id=="Product type(s)">   
        <row>
          <entry>${header1}</entry>
            <entry><@productTypes repeatableBlock "metaSpcId" "en"/></entry> 
        </row>  
      </#if>

      <#if numberOfColumns=="threeColTable" && id="Meta SPC Product composition additional">       
      <#list arraykeys as productDocument>
        <#if productDocument?has_content>
        <#assign tradeNameRepeatableBlock = productDocument.GeneralInformation.TradeNames/>
          <#local tradeNameCounter = 0 />
          <#list tradeNameRepeatableBlock as tradeSequence>
              <#if tradeSequence?has_content>
                  <#local tradeNameCounter = tradeNameCounter + 1 />
              </#if>
          </#list>
          <#list tradeNameRepeatableBlock as tradeSequence>
            <#if tradeSequence?has_content>
              <#if tradeSequence?index == 0>
                <row>
                  <entry morerows="${tradeNameCounter - 1}">${header1}</entry>
                  <entry><#if tradeSequence.TradeName?has_content><@com.text tradeSequence.TradeName /><#else></#if></entry>
                  <entry><#if tradeSequence.Country?has_content>${part_2_section_7_1_family_market} <@picklistMultipleWoutSemiColon tradeSequence.Country "countryDesc" /><#else></#if></entry>
                </row>
              <#else>
                <row>
                  <entry><#if tradeSequence.TradeName?has_content><@com.text tradeSequence.TradeName /><#else></#if></entry>
                  <entry>
                    <#if tradeSequence.Country?has_content>
                      ${part_2_section_7_1_family_market} <@picklistMultipleWoutSemiColon tradeSequence.Country "countryDesc" /><#else>
                    </#if>
                  </entry>
                </row>
              </#if>
            </#if>
          </#list>

          <#if productDocument.name?has_content>
            <row>
                <entry><para>${header3}</para></entry>  
                <entry colsep='0'><para></para></entry>
                <entry>
                  <para>
                  <#if productAuthorizationNumbersMap?has_content && spcFamilyContext?has_content>
                    ${getR4BPInjection(productDocument.name, "authorisationNumbers")}
                    ${getR4BPInjection("${repeatableBlock.name}", "metaSPCsuffices")}
                  <#else>
                  </#if>      
                  </para>
                </entry>
            </row>
          </#if>
        </#if>
      </#list> 
      </#if>

	    <#if numberOfColumns=="threeColTable" && id="Authorisation holder">
        <row>
          <entry morerows="1" valign="middle">${header1}</entry>              
          <entry>${header2}</entry>              
          <entry><para>
            <#if legalEntityNameEntry??>
              ${legalEntityNameEntry}
            <#elseif !(legalEntityNameEntry?has_content)>
              <@com.text externalAuthorisationName />
            </#if>
          </para></entry>
        </row>
        
        <row>
            <entry>${header3}</entry>
            <entry>
              <para>
              <@legalEntityFields "externalParameter"/>
              </para>
            </entry>
        </row>

        <row>              
            <entry><para>${header4}</para></entry>
            <entry colsep='0'></entry>
            <entry>
            <#if authNumber?has_content>
              <@com.text authNumber />
            <#elseif !(authNumber?has_content)>
              <@com.text externalAuthorisationNumber />
            </#if>
            </entry>
        </row>

        <row>              
            <entry><emphasis>${header5}</emphasis></entry>
            <entry colsep='0'></entry>
            <entry>
            <#if refAssetNumber?has_content>
              <@com.text refAssetNumber />
            <#elseif !(refAssetNumber?has_content)>
              <@com.text externalAuthorisationNumber />
            </#if>
            </entry>
        </row> 

        <row>              
            <entry >${header6}</entry>
            <entry colsep='0'></entry>
            <entry>
              <#if dateOfAuth?has_content>
                <@com.text dateOfAuth />
              <#elseif !(dateOfAuth?has_content)>
                <@com.text externalAuthorisationStartDate />
              </#if>              
            </entry>
        </row> 

        <row>              
            <entry >${header7}</entry>
            <entry colsep='0'></entry>
            <entry>
              <#if expiryDate?has_content>
                <@com.text expiryDate />
              <#elseif !(expiryDate?has_content)>
                  <@com.text externalAuthorisationEndDate />
              </#if>
            </entry>
        </row>      
      </#if> 
          
      <#if numberOfColumns=="twoColTable" && id="Trade name(s) of the product">
      <#if repeatableBlock?has_content> 
        <row>  
          <entry>${header1}</entry>
            <entry>
            <#if repeatableBlock?has_content>
            <#list repeatableBlock as item>
              <#if item?has_content>
                <#if item.TradeName?has_content><@com.text item.TradeName /><#else></#if>
              </#if><#if item_has_next><?linebreak?></#if>
            </#list>
            <#else></#if>
            </entry> 
        </row> 
      </#if>        
      </#if>

      <#if numberOfColumns=="twoColTable" && id="Formulation types summary" || id=="Formulation types meta spc">
        <row>  
          <entry>${header1}</entry>
            <entry>
            <#if id="Formulation types summary">
            <@formulationTypes mainMixtureCompositionSummaryList "${id}" />
            <#elseif id=="Formulation types meta spc">
            <@formulationTypes arraykeys "${id}" />
            </#if>
            </entry> 
        </row>     
      </#if>
        
      <#if numberOfColumns=="twoColTable" && id="Family name">
        <#if _subject.MixtureName?has_content> 
          <row>  
            <entry>${header1}</entry>
              <entry>
              <@com.text _subject.MixtureName />
              </entry> 
          </row> 
        </#if>        
      </#if>

      <#if numberOfColumns=="twoColTable" && id="Product type">      
        <row>  
            <entry>${header1}</entry>
            <entry><@productTypes usesList "usesListId" "en"/></entry>
        </row>
      </#if>      
      
      <#if numberOfColumns=="twoColTable" && id="Meta SPC Hazard and precautionary statements">   
           
        <row>
          <entry>${header1}</entry>    
          <entry><#if hazard?has_content>${hazard}</#if>
          <#if supplementalGHShazards?has_content>${supplementalGHShazards}</#if>
          <#if additionalLabels?has_content>${additionalLabels}</#if></entry>
        </row>
        <row>
          <entry>${header2} </entry>    
          <entry>
          <#if precautionary?has_content>${precautionary}</#if>
          </entry>
        </row>  
      </#if>

      <#if numberOfColumns=="twoColTable" && id="Hazard and precautionary statements">          
        <row>
          <entry>${header1}</entry>    
          <entry>
            <#if hazard?has_content>${hazard}</#if>
            <#if supplementalGHShazards?has_content>${supplementalGHShazards}</#if>
            <#if additionalLabels?has_content>${additionalLabels}</#if> 
          </entry>
        </row>
        <row>
          <entry>${header2} </entry>    
          <entry>
            <#if precautionary?has_content>${precautionary}</#if>
          </entry>
        </row>      
      </#if>

      <#if numberOfColumns=="twoColTable">

        <#if id="Manufacturer(s) of the product" || id="Manufacturer(s) of the active substance(s)">
                  
            <#if id="Manufacturer(s) of the active substance(s)">
            <row>
              <entry>${header1}</entry>    
              <entry> 
                <#if refSubstanceNameInSubstance?has_content>${refSubstanceNameInSubstance}<#else></#if>         
              </entry>
            </row>
            </#if>

            <row>
              <entry>${header2}</entry>    
              <entry>       
                <#if legalEntityNameEntry??>${legalEntityNameEntry}<#else></#if>
              </entry>
            </row>
            <row>
              <entry>${header3}</entry>    
              <entry>
                <@legalEntityFields/>
              </entry>
            </row>

            <row>
              <entry>${header4}</entry>                
                <#if id="Manufacturer(s) of the product" || id="Manufacturer(s) of the active substance(s)">                 
                    <entry>
                    <#-- repeatableBlock equals the Supplier LE -->
                      <#if repeatableBlock?has_content>
                        <#assign siteLocationWithMatchingSupplierLE = getSitesBelongingToSupplier(sitesList, arraykeys, repeatableBlock.documentKey.uuid, "${id}") />
                          <#if siteLocationWithMatchingSupplierLE?has_content>
                            <#list siteLocationWithMatchingSupplierLE as locations>
                                <msgtext><@com.text locations.name/>
                                    <msgtext><@com.value locations.ContactAddress.Address1/> <@com.value locations.ContactAddress.Address2/> <@com.value locations.ContactAddress.Postal/> <@com.value locations.ContactAddress.Town/> <@com.value locations.ContactAddress.Country/></msgtext>
                                    <#if locations?has_next><para></para></#if>
                                </msgtext>
                            </#list>             
                          </#if>
                      </#if>
                    </entry> 
                </#if>
            </row>
        </#if>
      </#if>
    </tbody>
    </tgroup>
  </informaltable>
<#if isMoreThanOneDoc??>
    <#if id="Manufacturer(s) of the product" || id="Manufacturer(s) of the active substance(s)" || id="Trade name(s) of the product">
        <@com.emptyLine/>
    </#if>
</#if>
</#compress>
</#macro>

<#function getMetaSPCdocName productCompositions>

    <#assign sites = [] />
    <#assign supplierReferenceKeyAS = [] />
    <#assign linkedLegalEntity = [] />
    <#assign sitesname = [] />
    <#local locale = [] />
    <#local locale = "en" />

    <#assign siteReferenceKeyAS = iuclid.getSectionDocumentsForParentKey(activeSubstances.documentKey, "FLEXIBLE_RECORD", "Sites") />

    <#list siteReferenceKeyAS as sites>
      <#if sites?has_content>
        <#assign supplierReferenceKeyAS = iuclid.getDocumentForKey(sites.ReferenceSite)/>
          <#if supplierReferenceKeyAS?has_content>
          <#assign sitesname = sitesname + [supplierReferenceKeyAS] />
          <#if supplierReferenceKeyAS.hasElement("OwnerLegalEntity")>
            <#local linkedLegalEntityInSite = iuclid.getDocumentForKey(supplierReferenceKeyAS.GeneralInfo.OwnerLegalEntity)/>
               <#assign sites = sites + [linkedLegalEntityInSite.documentKey.uuid]/>
          </#if>
          </#if>
      </#if>
    </#list>

    <#local uniqueSites = []/>
    <#list sites as item>
        <#if item?seq_contains(activeSubstancesSupplierListUUID)>
            <#local uniqueSites = uniqueTexts + [supplierReferenceKeyAS]/>
        </#if>
    </#list>
    <#return sitesname />

</#function>

<#function sitesLocationFunction activeSubstances supplierReferenceKeyAS activeSubstancesSupplierListUUID documentType="">

    <#assign sites = [] />
    <#assign supplierReferenceKeyAS = [] />
    <#assign linkedLegalEntity = [] />
    <#assign sitesname = [] />
    <#local locale = [] />
    <#local locale = "en" />

    <#--
    Sites doc: FLEXIBLE_RECORD.Sites
    Site ref [Location]:    linkedSite = iuclid.getDocumentForKey(locale.ReferenceSite)
    Legal entity referenced in Site ref:  local linkedLEinSite = iuclid.getDocumentForKey(locale.GeneralInfo.OwnerLegalEntity)

    Supplier doc: FLEXIBLE_RECORD.Suppliers.ManufacturerImportForm.LegalEntity
    Legal entity [Supplier]:   FLEXIBLE_RECORD.Suppliers.ManufacturerImportForm.LegalEntity
    -->

    <#assign siteReferenceKeyAS = iuclid.getSectionDocumentsForParentKey(activeSubstances.documentKey, "FLEXIBLE_RECORD", "Sites") />

    <#list siteReferenceKeyAS as sites>
      <#if sites?has_content>
        <#assign supplierReferenceKeyAS = iuclid.getDocumentForKey(sites.ReferenceSite)/>
          <#if supplierReferenceKeyAS?has_content>
          <#assign sitesname = sitesname + [supplierReferenceKeyAS] />
          <#if supplierReferenceKeyAS.hasElement("OwnerLegalEntity")>
            <#local linkedLegalEntityInSite = iuclid.getDocumentForKey(supplierReferenceKeyAS.GeneralInfo.OwnerLegalEntity)/>
               <#assign sites = sites + [linkedLegalEntityInSite.documentKey.uuid]/>
          </#if>
          </#if>
      </#if>
    </#list>

    <#local uniqueSites = []/>
    <#list sites as item>
        <#if item?seq_contains(activeSubstancesSupplierListUUID)>
            <#local uniqueSites = uniqueSites + [supplierReferenceKeyAS]/>
        </#if>
    </#list>
    <#return sitesname />

</#function>

<#function productTypeFunction usesList id="">

    <#assign localisedTexts = [] />
    <#local locale = [] />
    <#local locale = "en" />

    <#if id=="usesListId">
      <#list usesList as uses>
          <#if uses?has_content>
          <@localisedPhrases uses/>
          </#if>
      </#list>

    <#elseif id=="metaSpcId">
      
      <#list usesList.MetaSPC.AuthorisedUses as usesMetaSPC>
        <#assign useMetaSPC = iuclid.getDocumentForKey(usesMetaSPC)/>
        <#if useMetaSPC?has_content>
            <@localisedPhrases useMetaSPC/>
        </#if>
      </#list>
    
    </#if>

    <#local uniqueTexts = []/>
    <#list localisedTexts as item>
        <#if !(uniqueTexts?seq_contains(item))>
            <#local uniqueTexts = uniqueTexts + [item]/>
        </#if>
    </#list>
    <#return uniqueTexts/>

</#function>

<#macro localisedPhrases uses>
  <#list uses.IntendedUsesAndExposure.ProductType as myProdType>
    <#if myProdType?has_content && languageLocale?has_content>
        <#assign localizPhrase = iuclid.localizedPhraseDefinitionFor(myProdType.code "${languageLocale}")/>
        <#assign localisedTexts = localisedTexts + [localizPhrase.text]/>
    </#if>
  </#list>
</#macro>

<#-- headers which are horiztonally placed -->
<#macro horizontalHeaderTable arrayKeys isMoreThanOneDoc rootMixture repeatableBlock header1="" header2="" header3="" header4="" header5="" header6="" numberOfColumns="" id="">
<#compress>
	<informaltable frame="all">			

      <tgroup cols='6'>
				<colspec width="16.6%" />
				<colspec width="16.6%" />
        <colspec width="16.6%" />
        <colspec width="16.6%" />
        <colspec width="16.6%" />
        <colspec width="16.6%" />

				<tbody>

          <row>          
              <entry>${header1}</entry>
              <entry>${header2}</entry>
              <entry>${header3}</entry>
              <entry>${header4}</entry> 
              <entry>${header5}</entry>
              <entry>${header6}</entry>           
          </row> 
    
            <#-- iterate through repeatable block of components -->
            <#if arrayKeys?has_content>
              <#-- filter out *substance of concern, *TypicalConcentration is 0 and only apply to fields with element TypicalConcentration -->
              <#list arrayKeys?filter(item -> isNotSubstanceOfConcern(item)) as item>
              <#if item?has_content> 
                <#-- get the component key -->
                <#if id=="Qualitative and quantitative information on the composition of the product" || id=="Meta SPC Product composition">                
                <#local componentKey = iuclid.getDocumentForKey(item.Reference)/>

                <#elseif id=="Qualitative and quantitative information on the composition of the family summary" || id=="Qualitative and quantitative information on the composition of the meta spc">
                <#local componentKey = iuclid.getDocumentForKey(item.Name)/>
                </#if>

                    <#if componentKey?has_content>
                    <#-- macro to capture all values to identify the mixture's  components -->
                    <@substanceAndReferenceSubstanceIdentifiers componentKey item "${id}"/>
                      <#-- populate row if the component is a SUBSTANCE -->
                      <#if isSubstanceComponent(componentKey)>
                        <row>  
                        <entry><#if refSubstanceNameInSubstance?has_content>${refSubstanceNameInSubstance}<#else></#if></entry>
                        <entry><#if iupacSubstance?has_content>${iupacSubstance}<#else></#if></entry>
                        <entry><#if functionValue?has_content>${functionValue}<#else></#if></entry>    
                        <entry><#if casNumberSubstance?has_content>${casNumberSubstance}<#else></#if></entry>    
                        <entry><#if ecNumberSubstance?has_content>${ecNumberSubstance}<#else></#if></entry>    
                        <entry><#if concentrationLower?has_content>${concentrationLower}<#elseif concentrationRange?has_content>${concentrationRange}<#else></#if></entry>     
                        </row>
                      <#-- populate row if the component is a REFERENCE_SUBSTANCE -->
                      <#elseif !isSubstanceComponent(componentKey)>
                        <row>  
                        <entry><#if refSubstanceNameInSubstance?has_content>${refSubstanceNameInSubstance}<#else></#if></entry>
                        <entry><#if iupacReferenceSubstance?has_content>${iupacReferenceSubstance}<#else></#if></entry>
                        <entry><#if functionValue?has_content>${functionValue}<#else></#if></entry>    
                        <entry><#if casNumberReferenceSubstance?has_content>${casNumberReferenceSubstance}<#else></#if></entry>    
                        <entry><#if ecNumberReferenceSubstance?has_content>${ecNumberReferenceSubstance}<#else></#if></entry>    
                        <entry><#if concentrationLower?has_content>${concentrationLower}<#elseif concentrationRange?has_content>${concentrationRange}<#else></#if></entry>    
                        </row>
                      </#if>
                    </#if>
                  </#if>

              </#list>
            </#if>

        </tbody>
			</tgroup>
  </informaltable>
</#compress>
</#macro>

<#-- formal table for uses -->
<#macro useDescription isMoreThanOneDoc useMetaSPC indexcounter="" header1="" header2="" header3="" header4="" header5="" header6="" header7="" header8="">
<#compress>
<#if isMoreThanOneDoc??>
  <@com.emptyLine/>
</#if>

<table border="1">
    	
    <title>${useName}</title>
    <col width="40%" />
    <col width="60%" />	

    <tbody>
				<tr>        							
					<th>${header1}</th>
					<th> 
            ${productType}
          </th>
				</tr>

        <#if authorisedUseDescription?has_content>
          <tr>
            <td>${header2}</td>
            <td><#if authorisedUseDescription??>${authorisedUseDescription}</#if></td>
          </tr>
        </#if>

        <#if targetOrganism?has_content>
        <tr>
          <td>${header3}</td>
          <td><#if targetOrganism??>${targetOrganism}</#if></td>
        </tr>
        </#if>
        
        <#if fieldsOfUseDescription?has_content || fieldsOfUse?has_content>
          <tr>
            <td>${header4}</td>
            <td>
            <#if fieldsOfUse??>${fieldsOfUse}
            </#if>
            <@com.emptyLine />
            <#if fieldsOfUseDescription??>${fieldsOfUseDescription}</#if>
            </td>
          </tr>
        </#if>

        <#if applicationMethods?has_content>
        <tr>
          <td>${header5}</td>
          <td>${applicationMethods}</td>
        </tr>
        </#if>

        <#if applicationRates?has_content>
        <tr>
          <td>${header6}</td>
          <td><#if applicationRates??>${applicationRates}</#if></td>
        </tr>
        </#if>

        <#if categoriesOfUsers?has_content>
        <tr>
          <td>${header7}</td>
          <td><#if categoriesOfUsers??>${categoriesOfUsers}</#if></td>
        </tr>
        </#if>

        <#if packagingSizeAndMaterial?has_content>
        <tr>
          <td>${header8}</td>
          <td><#if packagingSizeAndMaterial??>${packagingSizeAndMaterial}</#if></td>
        </tr>
        </#if>

    </tbody>
</table>
</#compress>
</#macro>

<#---------------------------------------->
<#-- Functions to condition data output -->
<#---------------------------------------->

<#-- Only return if more than 1 doc in sequence -->
<#function isMoreThanOneDoc sectionDoc>
<#if sectionDoc?has_content && sectionDoc?size gt 0>
  <#return true>
  <#else>
    <#return false/>
</#if>
  <#return false/>
</#function>

<#------------------------------->
<#-- Functions providing array -->
<#------------------------------->

<#macro macroForListingUses usesList>

  <#assign uses = [] />

  <#if usesList?has_content>
  <#list usesList as use>
    <#if use?has_content>
      <#assign uses = uses + [use] />
    </#if>
  </#list>
  </#if>
  
</#macro>

<#------------------------------------------------------>
<#-- Functions providing data for sections and tables -->
<#------------------------------------------------------>

<#macro formulationTypes mainMixtureCompositionSummaryList id="">
<#if mainMixtureCompositionSummaryList?has_content>

  <#if id="Formulation types summary">
  <#list mainMixtureCompositionSummaryList as composition>
      <#if isFamilyComposition(composition) && composition.ProductSummaryComposition.FormulationType?has_content> 
        <@picklistMultipleWoutSemiColon composition.ProductSummaryComposition.FormulationType/>
      </#if>
  </#list>
  <#elseif id="Formulation types meta spc">      
      <#if mainMixtureCompositionSummaryList.ProductSummaryComposition.FormulationType?has_content>
        <@picklistMultipleWoutSemiColon mainMixtureCompositionSummaryList.ProductSummaryComposition.FormulationType/>
      </#if>
  </#if>
</#if> 
</#macro>

<#macro macroForUseData use languageLocale>
<#compress>
<#assign productType = [] />
<#assign useName = [] />
<#assign authorisedUseDescription = [] />
<#assign targetOrganism = [] />
<#assign fieldsOfUse = [] />
<#assign fieldsOfUseDescription = [] />
<#assign applicationMethods = [] />
<#assign applicationRates = [] />
<#assign categoriesOfUsers = [] />
<#assign packagingSizeAndMaterial = [] />
<#assign directionsForUse = [] />

    <#-- Table title with index counter -->
    <#assign useName>
      <#if use.IntendedUsesAndExposure.UseName?has_content>
        <@com.text use.IntendedUsesAndExposure.UseName />
        <#else>
        <@com.text use.name />
      </#if>
    </#assign>

    <#-- "Product type" data -->
    <#assign productType><@picklistMultipleWoutSemiColon use.IntendedUsesAndExposure.ProductType/></#assign>

    <#-- "Where relevant, an exact description of the authorised use" data -->
    <#assign authorisedUseDescription>
      <#if use.IntendedUsesAndExposure.DetailedDescription?has_content>
        <@iuclid.label for=use.IntendedUsesAndExposure.DetailedDescription var="fieldLabel"/>
          <@com.richText use.IntendedUsesAndExposure.DetailedDescription/>
          <#else>
      </#if>
    </#assign>

    <#-- "Target organism(s) (including development stage)" data -->
    <#assign targetOrganism>
    <#if use.IntendedUsesAndExposure.TargetOrganisms?has_content>
    <#assign targetOrganismsList = iuclid.getDocumentForKey(use.IntendedUsesAndExposure.TargetOrganisms)/>
    <#list targetOrganismsList.GeneralInformation.PestTargetOrganismsToBeControlled.TargetOrganisms as targetOrganisms>
      <#if targetOrganisms?has_content>

        <@iuclid.label for=targetOrganisms.ScientificName lang="${languageLocale}" var="sciNameLabel"/>
        <@iuclid.label for=targetOrganisms.CommonName lang="${languageLocale}" var="commonNameLabel"/>
        <@iuclid.label for=targetOrganisms.DevelopmentalStage lang="${languageLocale}" var="devStageLabel"/>
          
          <para>
            <#if targetOrganisms.ScientificName?has_content>
              ${part_2_table4_1_cell3_col2_family_table4_1_cell3_col2_single_sci} <@com.picklist targetOrganisms.ScientificName />
              <?linebreak?>
            </#if>

            <#if targetOrganisms.CommonName?has_content>              
                ${part_2_table4_1_cell3_col2_family_table4_1_cell3_col2_single_com} <@com.picklist targetOrganisms.CommonName />     
                <?linebreak?>       
            </#if>

            <#if targetOrganisms.DevelopmentalStage?has_content>             
                ${part_2_table4_1_cell3_col2_family_table4_1_cell3_col2_single_dev} <@com.picklist targetOrganisms.DevelopmentalStage />
                <?linebreak?>            
            </#if>
          </para>
      </#if>
    </#list>
    </#if>
    </#assign>

    <#-- "Field(s) of use" data -->
    <#assign fieldsOfUse>
      <@picklistMultipleWoutSemiColon use.IntendedUsesAndExposure.FieldOfUse/>
    </#assign>

    <#-- "Field of use description" data -->
    <#assign fieldsOfUseDescription>
      <@com.text use.IntendedUsesAndExposure.FieldOfUseDescription/>
    </#assign>
  
    <#-- "Application method(s)" data -->
    <#assign applicationMethods>  

      <#if use.IntendedUsesAndExposure.ApplicationMethods?has_content>
      <#list use.IntendedUsesAndExposure.ApplicationMethods as applications>
        <#if applications?has_content>
        <#local applicationMethod = iuclid.getDocumentForKey(applications)/>
        <#if applicationMethod?has_content>
          
          <@iuclid.label for=applicationMethod.DirectionsForUse.MethodOfApplication var="appMethodLabel"/>
          <@iuclid.label for=applicationMethod.DirectionsForUse.DetailedDescriptionOfMethod var="detailedDesLabel"/> 
          <@iuclid.label for=applicationMethod.DirectionsForUse.NumberAndTimingOfApplications var="numberAndTimings"/> 
          
          <#if applicationMethod.DirectionsForUse.MethodOfApplication?has_content || applicationMethod.DirectionsForUse.DetailedDescriptionOfMethod?has_content>
          ${part_2_table4_1_cell5_col2_family_table4_1_cell5_col2_single_meth} <@com.picklistMultiple applicationMethod.DirectionsForUse.MethodOfApplication />
          <@com.emptyLine />                     
          ${part_2_table4_1_cell5_col2_family_table4_1_cell5_col2_single_detail} <@com.text applicationMethod.DirectionsForUse.DetailedDescriptionOfMethod />        
          </#if>      
      </#if>
      </#if>
    </#list>
    </#if>
    </#assign>

    <#-- "Application rate(s) and frequency" data -->
    <#assign applicationRates>
      
      <#if use.IntendedUsesAndExposure.ApplicationMethods?has_content>
      <#list use.IntendedUsesAndExposure.ApplicationMethods as applications>
        <#if applications?has_content>
        <#local applicationMethod = iuclid.getDocumentForKey(applications)/>
        <#if applicationMethod?has_content>
          
          <@iuclid.label for=applicationMethod.DirectionsForUse.MethodOfApplication var="appMethodLabel"/>
          <@iuclid.label for=applicationMethod.DirectionsForUse.DetailedDescriptionOfMethod var="detailedDesLabel"/> 
          <@iuclid.label for=applicationMethod.DirectionsForUse.NumberAndTimingOfApplications var="numberAndTimings"/>

          <#if applicationMethod.DirectionsForUse.ApplicationDoseFinalConcentration?has_content>
          <#list applicationMethod.DirectionsForUse.ApplicationDoseFinalConcentration as concentrations>

            <#if concentrations.ApplicationDose?has_content && concentrations.hasElement("ApplicationDose")>
              ${part_2_table4_1_cell6_col2_family_table4_1_cell6_col2_single_app} <@com.range concentrations.ApplicationDose />
              <@com.emptyLine /> 
            <#elseif concentrations.Remarks?has_content>          
              ${part_2_table4_1_cell6_col2_family_table4_1_cell6_col2_single_app} <@com.text concentrations.Remarks />
              <@com.emptyLine /> 
            </#if>

            <#if concentrations.Dilution?has_content>
            ${part_2_table4_1_cell6_col2_family_table4_1_cell6_col2_single_dil} <@com.number concentrations.Dilution />
            </#if> 

            <#if concentrations.DilutionRemarks?has_content>
            ${part_2_table4_1_cell6_col2_family_table4_1_cell6_col2_single_dil} <@com.text concentrations.DilutionRemarks />
            </#if>
          </#list>
          </#if>

          <#if applicationMethod.DirectionsForUse.NumberAndTimingOfApplications?has_content>
          <@com.emptyLine />
            ${part_2_table4_1_cell6_col2_family_table4_1_cell6_col2_single_num} <@com.richText applicationMethod.DirectionsForUse.NumberAndTimingOfApplications />         
          </#if>
        </#if>
        </#if>
      </#list>
      </#if>
    </#assign>

    <#-- "Category(ies) of users" data -->
    <#assign categoriesOfUsers>
      <@com.picklistMultiple use.IntendedUsesAndExposure.User />
    </#assign>

    <#-- "Pack sizes and packaging material" data -->
    <#assign packagingSizeAndMaterial>
    <#if use.IntendedUsesAndExposure.Packagings?has_content>
      <#list use.IntendedUsesAndExposure.Packagings as packagings>
        <#if packagings?has_content>
        <#local packaging = iuclid.getDocumentForKey(packagings)/>
        <#if packaging?has_content>
          <@com.richText packaging.Packaging.AdditionalInfo />
        </#if>
        </#if>
      </#list>
    </#if>
    </#assign>

    <#if use.IntendedUsesAndExposure.InstructionsForUseAndMeasuresToProtect?has_content && use.hasElement("IntendedUsesAndExposure.InstructionsForUseAndMeasuresToProtect")>
     <#assign directionsForUse = iuclid.getDocumentForKey(use.IntendedUsesAndExposure.InstructionsForUseAndMeasuresToProtect)/>
     <#else>          
    </#if>
</#compress>
</#macro>

<#macro directionsForUseReferencedByAuthorisedUses useMetaSPC id="">
<#compress>
 <#if id=="Meta SPC Use description" || id=="Use description">

  <!-- 4.1.1 Use-specific instructions for use -->
  <section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_4_1_1_family_section_4_1_1_single}</title>
  <@macroForUseData useMetaSPC "${languageLocale}" />  
  <#if directionsForUse?has_content && directionsForUse.hasElement("UseSpecificInstructionsForUse") && directionsForUse.UseSpecificInstructionsForUse?has_content>
  <@com.value directionsForUse.UseSpecificInstructionsForUse />
  <#else>
  </#if>
  </section>
  
  <!-- 4.1.2 Use-specific risk mitigation measures -->
  <section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_4_1_2_family_section_4_1_2_single}</title>
 
  <#if directionsForUse?has_content && directionsForUse.hasElement("UseSpecificRiskMitigationMeasuresStandarisedPhrases") && directionsForUse.UseSpecificRiskMitigationMeasuresStandarisedPhrases?has_content>
  
    <#list directionsForUse.UseSpecificRiskMitigationMeasuresStandarisedPhrases as block>
      <#if block?has_content>
        ${com.getFilledPhraseText(block, block.code, block.otherText, parameterisedPhraseNotRelevant)}
      </#if>
      <#if block_has_next><para></para></#if>
    </#list>  
  </#if>
  </section>
  
  <!-- 4.1.3 Use-specific risk mitigation measures -->
  <section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_4_1_2_family_section_4_1_2_single}</title>

  <#if directionsForUse?has_content && directionsForUse.hasElement("UseSpecificRiskMitigationMeasures") && directionsForUse.UseSpecificRiskMitigationMeasures?has_content>
  <@com.richText directionsForUse.UseSpecificRiskMitigationMeasures />
  <#else></#if>

  </section>

  <!-- 4.1.4 Where specific to the use, the particulars of likely direct or indirect effects, first aid instructions and emergency measures to protect the environment -->
  <section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_4_1_3_family_section_4_1_3_single}</title>

  <#if directionsForUse?has_content && directionsForUse.hasElement("SpecificToTheUseTheParticularsOfLikelyDirectOrIndirectEffects") && directionsForUse.SpecificToTheUseTheParticularsOfLikelyDirectOrIndirectEffects?has_content>
  <@com.richText directionsForUse.SpecificToTheUseTheParticularsOfLikelyDirectOrIndirectEffects />
  <#else></#if>    

  </section>

  <!-- 4.1.5 Where specific to the use, the instructions for safe disposal of the product and its packaging -->
  <section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_4_1_4_family_section_4_1_4_single}</title>
  <#if directionsForUse?has_content && directionsForUse.hasElement("WhereSpecificToTheUseTheInstructionsForSafeDisposalOfTheProductAndItsPackaging") && directionsForUse.WhereSpecificToTheUseTheInstructionsForSafeDisposalOfTheProductAndItsPackaging?has_content>
  <@com.richText directionsForUse.WhereSpecificToTheUseTheInstructionsForSafeDisposalOfTheProductAndItsPackaging />
  <#else></#if>
  
  </section>

  <!-- 4.1.6 Where specific to the use, the conditions of storage and shelf-life of the product under normal conditions of storage -->
  <section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_4_1_5_family_section_4_1_5_single}</title>

  <#if directionsForUse?has_content && directionsForUse.hasElement("SpecificToTheUseTheConditionsOfStorageAndShelfLifeOfTheProduct") && directionsForUse.SpecificToTheUseTheConditionsOfStorageAndShelfLifeOfTheProduct?has_content>
  <@com.richText directionsForUse.SpecificToTheUseTheConditionsOfStorageAndShelfLifeOfTheProduct />
  <#else></#if>

  </section>

</#if>
</#compress>
</#macro>

<#macro directionsForUseForMetaSPC generalDirectionsForUseMetaSPC id="">
<#compress>
<!-- 5.1 Instructions for use -->
<section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_5_1_family_part_2_section_5_1_single}</title>
<#if id=="Meta SPC Use description"><#t>
  <#if generalDirectionsForUseMetaSPC?has_content>
  <@com.richText generalDirectionsForUseMetaSPC.InstructionsForUse.InstructionsForUse /><#else>
  </#if>
<#else>
  <#if protectionMeasuresNotLinkedToUses?has_content>
  <#list protectionMeasuresNotLinkedToUses as proMeasures>
    <#if proMeasures?has_content>
    <@com.richText proMeasures.InstructionsForUse.InstructionsForUse /><#else>
    </#if>
  </#list>
  </#if>
</#if>
</section>

<!-- 5.2 Risk mitigation measures or 'Risk mitigation measures' -->
<section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_5_2_family_part_2_section_5_2_single}</title>
<#if id=="Meta SPC Use description"><#t>
  <#if generalDirectionsForUseMetaSPC?has_content>
    <#list generalDirectionsForUseMetaSPC.MeasuresToProtect.RiskMitigationMeasures as block>
      <#if block?has_content>
        ${com.getFilledPhraseText(block, block.code, block.otherText, parameterisedPhraseNotRelevant)}
      </#if>
      <#if block_has_next><para></para></#if>
    </#list>
  </#if> 
<#else>
  <#if protectionMeasuresNotLinkedToUses?has_content>
    <#list protectionMeasuresNotLinkedToUses as proMeasures>
      <#if proMeasures?has_content>        
        <#list proMeasures.MeasuresToProtect.RiskMitigationMeasures as block>
          <#if block?has_content>
            ${com.getFilledPhraseText(block, block.code, block.otherText, parameterisedPhraseNotRelevant)}
          </#if>
          <#if block_has_next><para></para></#if>
        </#list>
      </#if>
    </#list>  
  </#if>
</#if>
</section>

<!-- 5.3 Risk mitigation measures or 'Particulars of likely direct or indirect effects, first aid instructions and emergency measures to protect the environment' -->
<section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_5_2_family_part_2_section_5_2_single}</title>
<#if id=="Meta SPC Use description"><#t>
  <#if generalDirectionsForUseMetaSPC?has_content>
  <@com.richText generalDirectionsForUseMetaSPC.MeasuresToProtect.ControlMeasuresOfRepellents /><#else>
  </#if> 
<#else>
  <#if protectionMeasuresNotLinkedToUses?has_content>
  <#list protectionMeasuresNotLinkedToUses as proMeasures>
    <#if proMeasures?has_content>
      <@com.richText proMeasures.MeasuresToProtect.ControlMeasuresOfRepellents /><#else>
    </#if>
  </#list>  
  </#if>
</#if>
</section>

<!-- 5.4 Particulars of likely direct or indirect effects, first aid instructions and emergency measures to protect the environment -->
<section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_5_3_family_part_2_section_5_3_single}</title>
<#if id=="Meta SPC Use description"><#t>
  <#if generalDirectionsForUseMetaSPC?has_content>
  <@com.richText generalDirectionsForUseMetaSPC.MeasuresToProtect.ParticularsOfLikelyDirect /><#else>
  </#if>
<#else>
  <#if protectionMeasuresNotLinkedToUses?has_content>
  <#list protectionMeasuresNotLinkedToUses as proMeasures>
    <#if proMeasures?has_content>
      <@com.richText proMeasures.MeasuresToProtect.ParticularsOfLikelyDirect /><#else>
    </#if>
  </#list> 
  </#if>
</#if>
</section>

<!-- 5.5 Instructions for safe disposal of the product and its packaging -->
<section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_5_4_family_part_2_section_5_4_single}</title>
<#if id=="Meta SPC Use description"><#t>
  <#if generalDirectionsForUseMetaSPC?has_content>
  <@com.richText generalDirectionsForUseMetaSPC.ProceduresForWasteManagement.InstructionsForSafeDisposal /><#else>
  </#if>
<#else>
  <#if protectionMeasuresNotLinkedToUses?has_content>
  <#list protectionMeasuresNotLinkedToUses as proMeasures>
    <#if proMeasures?has_content>
      <@com.richText proMeasures.ProceduresForWasteManagement.InstructionsForSafeDisposal /><#else>
    </#if>
  </#list>
  </#if>
</#if>
</section>

<!-- 5.6 Conditions of storage and shelf-life of the product under normal conditions of storage -->
<section><title role="HEAD-4"><@addWhiteSpaces 2/>${part_2_section_5_5_family_part_2_section_5_5_single}</title>
<#if id=="Meta SPC Use description"><#t>
  <#if generalDirectionsForUseMetaSPC?has_content>
  <@com.richText generalDirectionsForUseMetaSPC.MeasuresToProtect.RecommendedMethodsAndPrecautionsConcerningStorage /><#else>
  </#if>
<#else>
  <#if protectionMeasuresNotLinkedToUses?has_content>
  <#list protectionMeasuresNotLinkedToUses as proMeasures>
    <#if proMeasures?has_content>
      <@com.richText proMeasures.MeasuresToProtect.RecommendedMethodsAndPrecautionsConcerningStorage /><#else>
    </#if>
  </#list>
  </#if>
</#if>
</section>
</#compress>
</#macro>

<#macro otherInformation bioSummaryList id="">
<#compress>
<#if id=="Meta SPC Other information">

    <#if bioSummaryList?has_content && bioSummaryList.hasElement("OtherInformation")>
        <@com.richText bioSummaryList.OtherInformation.OtherInformation /><#else>
    </#if>

<#else>

    <#if summaryAndEvaluationList?has_content>
      <#list summaryAndEvaluationList as otherInformation>
      <#if otherInformation?has_content && otherInformation.hasElement("OtherInformation")>
        <@com.richText otherInformation.OtherInformation.OtherInformation /><#else>
      </#if>
      </#list>
    </#if>     
</#if>
</#compress>
</#macro>

<#-- to remove when com takes over -->
<#macro macroForPopulatingLegalEntity legal id="">
<#if legal?has_content>
  <#assign legalEntityuuid>
      <#if legal.documentKey.uuid?has_content>${legal.documentKey.uuid}<#else>dummystring</#if>
  </#assign>
  <#assign legalEntityNameEntry>
      <#if legal.GeneralInfo.LegalEntityName?has_content><@com.text legal.GeneralInfo.LegalEntityName/></#if>
  </#assign>
  <#assign leAddress1>
      <#if legal.GeneralInfo.ContactAddress.Address1?has_content><@com.text legal.GeneralInfo.ContactAddress.Address1/></#if>
  </#assign>
  <#assign leAddress2>
      <#if legal.GeneralInfo.ContactAddress.Address2?has_content><@com.text legal.GeneralInfo.ContactAddress.Address2/></#if>
  </#assign>
  <#assign postalCode>
      <#if legal.GeneralInfo.ContactAddress.Postal?has_content><@com.text legal.GeneralInfo.ContactAddress.Postal/></#if>
  </#assign>
  <#assign town>
      <#if legal.GeneralInfo.ContactAddress.Town?has_content><@com.text legal.GeneralInfo.ContactAddress.Town/></#if>
  </#assign>
  <#assign country>
    <#if legal.GeneralInfo.ContactAddress.Country?has_content><@com.picklist legal.GeneralInfo.ContactAddress.Country/></#if>
  </#assign>
</#if>
</#macro>

<#macro legalEntityFields externalParameter=true>
<#if leAddress1??><@com.text leAddress1/>
  <#elseif !(legalEntityNameEntry?has_content)>
    <@com.text externalAuthorisationAddressStreet />
</#if> 

<#if leAddress2??><@com.text leAddress2/><#else></#if> 

<#if postalCode??><@com.text postalCode/>
  <#elseif !(legalEntityNameEntry?has_content)>
    <@com.text externalAuthorisationAddressPostalCode />
</#if> 

<#if town??><@com.text town />
  <#elseif !(legalEntityNameEntry?has_content)>
    <@com.text externalAuthorisationAddressCity />
</#if> 

<#if country??><@com.text country />
  <#elseif !(legalEntityNameEntry?has_content)>
    <@com.text externalAuthorisationAddressCountry />
</#if>
</#macro>

<#macro macroForPopulatingSite legal id="">
<#compress>
<#if legal?has_content>
  <#assign siteuuid>
      <#if legal.documentKey.uuid?has_content>${legal.documentKey.uuid}<#else></#if>
  </#assign>
  <#assign siteEntityNameEntry>   
      <#if legal.GeneralInfo.SiteName?has_content><@com.text legal.GeneralInfo.SiteName/></#if>
  </#assign>
</#if>
</#compress>
</#macro>

<#macro substanceAndReferenceSubstanceIdentifiers componentKey item id="">
<#compress>
<#assign refSubstanceNameInSubstance = []>

    <#-- substance component -->
    <#if isSubstanceComponent(componentKey)>
      <#if componentKey?has_content && componentKey.hasElement("ReferenceSubstance")>
        <#assign referenceSubstance = iuclid.getDocumentForKey(componentKey.ReferenceSubstance.ReferenceSubstance)/>
          <#if referenceSubstance?has_content>

            <#-- reference substance name -->
            <#assign refSubstanceNameInSubstance>
            <#-- if *SUBSTANCE, *function=active substance, *language==!(EN) -->
            
            <#---------------------------------------------------------------------- 
            ------------------------------------------------------------------------
            if not coming from active substance in manufacturer's block section 1_5 
            if the function, if applicable, is active substance
            ------------------------------------------------------------------------
            ----------------------------------------------------------------------->
            <#if isComponentActiveSubstance(item) && languageLocale!="en">
              
                  <#if languageFromBPRactiveSubstanceList(referenceSubstance.Synonyms.Synonyms)>
                    <#list referenceSubstance.Synonyms.Synonyms as synonyms>
                      <#if synonyms.Remarks?matches("${languageLocale?upper_case}")>     
                      <#-- non EN name -->
                      <@com.text synonyms.Name />                
                      </#if>     
                    </#list>
                  <#else>
                      <@com.referenceSubstanceName com.getReferenceSubstanceKey(componentKey.ReferenceSubstance.ReferenceSubstance) />  
                  </#if>               
            <#else>          
                <#-- if *SUBSTANCE, *function=!(active substance) or *function=active substance and *language==EN -->
                <@com.referenceSubstanceName com.getReferenceSubstanceKey(componentKey.ReferenceSubstance.ReferenceSubstance) />
            </#if>

            </#assign>

            <#-- EC Number -->
            <#assign ecNumberSubstance><@com.inventoryECNumber com.getReferenceSubstanceKey(componentKey.ReferenceSubstance.ReferenceSubstance) /></#assign>
            <#-- CAS Number -->
            <#assign casNumberSubstance><#if referenceSubstance.Inventory.CASNumber?has_content><@com.text referenceSubstance.Inventory.CASNumber/></#if></#assign>
              <#-- IUPAC Number -->
            <#assign iupacSubstance><#if referenceSubstance.IupacName?has_content><@com.text referenceSubstance.IupacName/></#if></#assign>         
        </#if>       
      </#if>
    </#if>

    <#-- reference substance component -->
    <#if !isSubstanceComponent(componentKey)>

      <#if componentKey?has_content>
         <#-- reference substance name -->
        <#assign refSubstanceNameInSubstance>
        <#-- if *SUBSTANCE, *function=active substance, *language==!(EN) -->
        
        <#---------------------------------------------------------------------- 
        ------------------------------------------------------------------------
        if not coming from active substance in manufacturer's block section 1_5 
        if the function, if applicable, is active substance
        ------------------------------------------------------------------------
        ----------------------------------------------------------------------->
        <#if isComponentActiveSubstance(item) && languageLocale!="en">
          
              <#if languageFromBPRactiveSubstanceList(componentKey.Synonyms.Synonyms)>
                <#list componentKey.Synonyms.Synonyms as synonyms>
                  <#if synonyms.Remarks?matches("${languageLocale?upper_case}")>     
                  <#-- non EN name -->
                  <@com.text synonyms.Name />                
                  </#if>     
                </#list>
              <#else>
                  <#if componentKey.ReferenceSubstanceName?has_content><@com.text componentKey.ReferenceSubstanceName/><#else></#if>
              </#if>               
        <#else>          
            <#-- if *SUBSTANCE, *function=!(active substance) or *function=active substance and *language==EN -->
            <#if componentKey.ReferenceSubstanceName?has_content><@com.text componentKey.ReferenceSubstanceName/><#else></#if>
        </#if>

        </#assign>
        
        <#-- IUPAC Number -->
        <#assign iupacReferenceSubstance><#if componentKey.IupacName?has_content><@com.text componentKey.IupacName/></#if></#assign>
        <#-- CAS Number -->
        <#assign casNumberReferenceSubstance><#if componentKey.Inventory.CASNumber?has_content><@com.text componentKey.Inventory.CASNumber/></#if></#assign>
        <#-- EC Number -->
        <#if id=="Qualitative and quantitative information on the composition of the product" || id=="Meta SPC Product composition">                
          <#assign ecNumberReferenceSubstance><@com.inventoryECNumber com.getReferenceSubstanceKey(item.Reference) /></#assign> 
        <#elseif id=="Qualitative and quantitative information on the composition of the family summary" || id="Qualitative and quantitative information on the composition of the meta spc">
          <#assign ecNumberReferenceSubstance><@com.inventoryECNumber com.getReferenceSubstanceKey(item.Name) /></#assign> 
        </#if>
      </#if>
    </#if>
    
    <#-- Function of component -->
    <#assign functionValue>

      <#if item.Function?has_content>
        <#assign function = item.Function />

        <#if com.picklistValueMatchesPhrases(function, ["active substance"])>
          <@com.value function/>

        <#elseif com.picklistValueMatchesPhrases(function, ["releaser"])>
          <@com.value function />

        <#elseif !(com.picklistValueMatchesPhrases(function, ["active substance", "releaser"]))>        
          <para>${non_active_aubstance_family_single}</para>
        </#if>

      </#if>
    </#assign>

    <#-- Content % of component for product -->
    <#assign concentrationLower>
    <#if id=="Qualitative and quantitative information on the composition of the product" || id=="Meta SPC Product composition" && item.TypicalConcentration?has_content>
      <#assign concentration = item.TypicalConcentration />
      <#if concentration.lower.value?has_content><@com.number concentration.lower.value/></#if>
    </#if>
    </#assign>
    
    <#-- Content % of component for summary -->
    <#assign concentrationRange>
    <#if id=="Qualitative and quantitative information on the composition of the family summary" || id="Qualitative and quantitative information on the composition of the meta spc" && item.Concentration?has_content>
      <@com.range item.Concentration />
    </#if>
    </#assign>
</#compress>
</#macro>

<#function languageFromBPRactiveSubstanceList synonym>

  <#if synonym?has_content>
  <#list synonym as synonyms>
    <#local languageInReferenceSubstance = synonyms.Remarks/>
      <#if languageInReferenceSubstance?matches("${languageLocale?upper_case}")>              
        <#return true>
      </#if>
  </#list>
  </#if>
 <#return false>
</#function>

<#macro concentrationAllConcentrations item id="">
<#compress>
<#-- Content % of component for product *differentiated between insitu versus non insitu, and family -->

    <#local typicalConcentration>
    <#if item.hasElement("TypicalConcentration")>
      <#if item.TypicalConcentration?has_content> 
        <#assign concentration = item.TypicalConcentration/>
          <#if concentration.lower.value?has_content><@com.number concentration.lower.value/></#if>
      </#if>
    </#if>
    </#local>      

    <#assign inSituCheckbox = item.SubstanceGeneratedInSitu/>

    <#if id=="Qualitative and quantitative information on the composition of the family summary" || id=="Qualitative and quantitative information on the composition of the meta spc" && item.Concentration?has_content>
      <@com.range item.Concentration />

    <#elseif inSituCheckbox??>
      <#if id=="Qualitative and quantitative information on the composition of the product" || id=="Meta SPC Product composition">        
          ${typicalConcentration}
           <#if item.ConcentrationRange?has_content && item.hasElement("ConcentrationRange")>
            <@com.value item.ConcentrationRange />
          </#if>        
      </#if>
    
    <#elseif !(inSituCheckbox??) && id=="Qualitative and quantitative information on the composition of the product" || id=="Meta SPC Product composition">
      ${typicalConcentration}
    </#if>
</#compress>
</#macro>

<#macro macroForPopulatingGhsLabelling array id="">
<#compress>
<#assign hazard = [] />
<#assign precautionary = [] />
<#assign supplementalGHShazards = [] />
<#assign additionalLabels = [] />
<#assign ghs = [] />

<#if id="Meta SPC Hazard and precautionary statements">
    <#if array.MetaSPC.ClassificationAndLabelling?has_content>

      <#assign ghs = iuclid.getDocumentForKey(array.MetaSPC.ClassificationAndLabelling)/>
      <#-- standard hazard statements -->
      <#assign hazardStatementList = ghs.Labelling.HazardStatementsBlock.HazardStatements />
      <#assign hazard><@keyClassifcationAndLabellingInformation.HazardStatementList hazardStatementList "${param}"/></#assign>

      <#-- standard precuationary statements -->
      <#assign precautionaryStatementList = ghs.Labelling.PrecautionaryStatementsBlock.PrecautionaryStatements />
      <#assign precautionary><@keyClassifcationAndLabellingInformation.PrecautionaryStatementsList precautionaryStatementList "${param}"/></#assign>

      <#-- supplemental GHS hazard statements -->  
      <#if !(ghs.Labelling.LabelingRequirementsBlock.LabelingRequirements?has_content)>
      <#else>
        <para>
          <#assign supplementalGHShazards><@keyClassifcationAndLabellingInformation.SupplimentalHazardStatementList ghs.Labelling.LabelingRequirementsBlock.LabelingRequirements "${param}"/> </#assign>
        </para>
      </#if>

      <#-- additional non-GHS labelling  -->    
      <#if !(ghs.Labelling.LabelingRequirementsBlock.AdditionalLabelling?has_content)>
      <#else>		      
        <para>
          <emphasis role="underline">Additional labelling:</emphasis>
          <#assign additionalLabels><@keyClassifcationAndLabellingInformation.AdditionalLabellingList ghs.Labelling.LabelingRequirementsBlock.AdditionalLabelling/></#assign>
        </para>      
      </#if>
    </#if>
  
<#elseif id="Hazard and precautionary statements">

    <#list ghsList as ghs>
      <#if ghs?has_content>

        <#-- standard hazard statements -->
        <#assign hazardStatementList = ghs.Labelling.HazardStatementsBlock.HazardStatements />
        <#assign hazard><@keyClassifcationAndLabellingInformation.HazardStatementList hazardStatementList "${param}"/></#assign>

        <#-- standard precuationary statements -->
        <#assign precautionaryStatementList = ghs.Labelling.PrecautionaryStatementsBlock.PrecautionaryStatements />           
        <#assign precautionary><@keyClassifcationAndLabellingInformation.PrecautionaryStatementsList precautionaryStatementList "${param}"/></#assign>

        <#-- supplemental GHS hazard statements -->  
        <#if !(ghs.Labelling.LabelingRequirementsBlock.LabelingRequirements?has_content)>
        <#else>    
          <para>
            <#assign supplementalGHShazards><@keyClassifcationAndLabellingInformation.SupplimentalHazardStatementList ghs.Labelling.LabelingRequirementsBlock.LabelingRequirements "${param}"/> </#assign>
          </para>     
        </#if>  

        <#-- additional non-GHS labelling  -->    
        <#if !(ghs.Labelling.LabelingRequirementsBlock.AdditionalLabelling?has_content)>
        <#else>		      
          <para>
            <emphasis role="underline">Additional labelling:</emphasis>
            <#assign additionalLabels> <@keyClassifcationAndLabellingInformation.AdditionalLabellingList ghs.Labelling.LabelingRequirementsBlock.AdditionalLabelling/></#assign>
          </para>      
        </#if>

    </#if>

    </#list>

  </#if>
</#compress>
</#macro>


<#---------------->
<#-- Functions  -->
<#---------------->

<#-- get the active substance components for only *SUBSTANCE and *REFERENCE_SUBSTANCE -->
<#function getActiveSubstanceComponents mainMixtureCompositionList>
<#local activeSubstanceComponents = [] />

<#if !(mainMixtureCompositionList?has_content)>
  <#return [] />
</#if>

<#list mainMixtureCompositionList as composition>
  <#if composition?has_content>
 
    <#local componentList = composition.Components.Components/>
    
    <#list componentList as component>
      <#if component?has_content>
        <#if isSubstanceOrReferenceSubstance(component, "componentProduct")>
        <#if isComponentActiveSubstance(component)>
          <#local activeSubstanceComponents = activeSubstanceComponents + [component]/>
        </#if>
        </#if>
      </#if>			
    </#list>
  </#if>
</#list>

	<#return activeSubstanceComponents/>
</#function>


<#-- get the active substance components from product summary for only *SUBSTANCE and *REFERENCE_SUBSTANCE -->
<#function getActiveSubstanceSummaryComponents mainMixtureCompositionSummaryList>
<#assign activeSubstanceSummaryComponents = [] />

<#if !(mainMixtureCompositionSummaryList?has_content)>
  <#return [] />
</#if>

<#list mainMixtureCompositionSummaryList as summaryComposition>
 
 <#if summaryComposition?has_content>
 
    <#list summaryComposition.ProductSummaryComposition.Composition as component>
    
      <#if component?has_content>
        <#if isSubstanceOrReferenceSubstance(component, "componentSummary")>
        <#if isComponentActiveSubstance(component)>
          <#assign activeSubstanceSummaryComponents = activeSubstanceSummaryComponents + [component]/>          
        </#if>
        </#if>        
      </#if>
      		
    </#list>
  </#if>
  <#return activeSubstanceSummaryComponents/>
</#list>
	
</#function>

<#-- get a list of summary compositions -->
<#function getSummaryCompositions mainMixtureCompositionSummaryList summaryType="">
<#local summaryCompositionsList = [] />

<#if !(mainMixtureCompositionSummaryList?has_content)>
  <#return [] />
</#if>

<#list mainMixtureCompositionSummaryList as compositions>
 
  <#if compositions?has_content>
    
      <#if isMetaSPCcomposition(compositions) && summaryType=="metaspc"> 
      <#local summaryCompositionsList = summaryCompositionsList + [compositions]/>
      </#if>

  </#if>
</#list>
	<#return summaryCompositionsList/>
</#function>

<#-- check if function is Active Substance -->
<#function isComponentActiveSubstance component>
	<#return component.Function?has_content && com.picklistValueMatchesPhrases(component.Function, ["active substance"]) />
</#function>

<#-- check if summary is a family composition -->
<#function isFamilyComposition compositionFamilySummaries>
<#assign metaSPC = compositionFamilySummaries.ProductSummaryComposition.RepresentsMetaSPC />
<#if !metaSPC>
  <#return true>
    <#else>
    <#return false>
</#if>
    <#return false/>
</#function>

<#-- check if summary is a meta spc composition -->
<#function isMetaSPCcomposition compositionFamilySummaries>

<#assign metaSPC = compositionFamilySummaries.ProductSummaryComposition.RepresentsMetaSPC />
  <#if metaSPC>
    <#return true>
      <#else>
      <#return false>
  </#if>
  <#return false/>
</#function>

<#-- get the substance components for only *SUBSTANCE and *REFERENCE_SUBSTANCE from a Mixture composition product -->
<#function getComponents productComposition id="">
<#local substanceComponents = [] />
<#local substanceComp = [] />

<#if !(productComposition?has_content)>
  <#return [] />
</#if>

<#if productComposition?has_content>

    <#if id="Qualitative and quantitative information on the composition of the product">
    
      <#list productComposition as composition>
        <#if composition?has_content>
      
          <#local componentList = composition.Components.Components/>
          
          <#list componentList as component>
            <#if component?has_content>
              <#if isSubstanceOrReferenceSubstance(component, "componentProduct")>
                <#local substanceComponents = substanceComponents + [component]/>
              </#if>	
            </#if>			
          </#list>
        </#if>
      </#list>

    <#elseif id="Meta SPC Product composition">

        <#local componentList = productComposition.Components.Components/>    
          <#list componentList as component>
          <#if isSubstanceOrReferenceSubstance(component, "componentProduct")>
            <#if component?has_content>
              <#local substanceComponents = substanceComponents + [component]/>         
            </#if>	
          </#if>		
          </#list>
    </#if>
        
</#if>

	<#return substanceComponents/>
</#function>

<#-- get the substance components for only *SUBSTANCE and *REFERENCE_SUBSTANCE from a Mixture composition summary -->
<#function getSummaryFamilyComposition mainMixtureCompositionSummaryList summaryType="">
<#local summaryComponents = [] />

<#if !(mainMixtureCompositionSummaryList?has_content)>
  <#return [] />
</#if>

<#list mainMixtureCompositionSummaryList as composition>
  <#if composition?has_content>
 
    <#local componentList = composition.ProductSummaryComposition.Composition/>
    
    <#list componentList as component>
      <#if component?has_content>
        <#if isFamilyComposition(composition) && summaryType=="family"> 

          <#if isSubstanceOrReferenceSubstance(component, "componentSummary")>
            <#local summaryComponents = summaryComponents + [component]/>
          </#if>

        <#elseif isMetaSPCcomposition(composition) && summaryType=="metaspc"> 

          <#if isSubstanceOrReferenceSubstance(component, "componentSummary")>
            <#local summaryComponents = summaryComponents + [component]/>
          </#if>

        </#if>	
      </#if>			
    </#list>
  </#if>
</#list>
	<#return summaryComponents/>
</#function>


<#function isSubstanceOrReferenceSubstance component componentDefinition="">

<#if componentDefinition=="componentProduct">
<#local componentType = iuclid.getDocumentForKey(component.Reference)/>
<#elseif componentDefinition=="componentSummary">
<#local componentType = iuclid.getDocumentForKey(component.Name)/>
</#if>

  <#if componentType?has_content>
  <#if componentType.documentType=="SUBSTANCE" || componentType.documentType=="REFERENCE_SUBSTANCE">
      <#return true >
    <#else>
      <#return false />
  </#if>
  </#if>
      <#return false />
</#function>

<#function getSitesBelongingToSupplier sitesList activeSubstanceSitesList suppliersFirstKey id="">

  <#assign mylinkedLE = []/>

  <#if id="Manufacturer(s) of the product">
  <#assign mylinkedLE = suppliersAndLocations(sitesList, suppliersFirstKey)/>
  <#elseif id="Manufacturer(s) of the active substance(s)">
  <#assign mylinkedLE = suppliersAndLocations(activeSubstanceSitesList, suppliersFirstKey)/>
  </#if>

  <#return mylinkedLE/>
</#function>

<#function suppliersAndLocations sitesList, suppliersFirstKey, id="">
<#assign mylinkedSite = []/>

  <#if sitesList?has_content>
    <#list sitesList as sites>
      <#if sites?has_content>
        <#assign linkedSite = iuclid.getDocumentForKey(sites.ReferenceSite)/>
        <#if linkedSite?has_content>
          <#local linkedLegalEntity = iuclid.getDocumentForKey(linkedSite.GeneralInfo.OwnerLegalEntity)/>
          <#if linkedLegalEntity?has_content && linkedLegalEntity.documentKey.uuid == suppliersFirstKey>
            <#assign mylinkedSite = mylinkedSite + [linkedSite]/>
          </#if>
        </#if>
      </#if>
    </#list>
  </#if>
<#return mylinkedSite/>
</#function>

<#function isSameLocationAsSupplier locationLegalEntity supplierLegalEntity="">

  <#if !(legalEntityuuid)?has_content>
  <#return false/>
  <#else>

    <#local supplierUUID><@com.text legalEntityuuid/></#local>
    <#if locationLegalEntity?has_content && locationLegalEntity.documentKey.uuid == supplierLegalEntity>
        <#return true>
      <#else>
        <#return false>
    </#if>

  </#if>
    <#return false/>
</#function>

<#function isSubstanceComponent componentKey>
  <#if componentKey.documentType=="SUBSTANCE">
    <#return true>
  <#else>
    <#return false>
  </#if>
    <#return false>
</#function>

<#function isNotSubstanceOfConcern component>

  <#assign soc = component.SubstanceOfConcern />
  <#assign socNumberLower=[]>
  <#assign socNumberUpper=[]>
  <#assign concentrationInformation=[]>

  <#assign concentrationInformation>
  <#if component.hasElement("Concentration")>
    <#assign socConcentration = component.Concentration />
    <#assign socNumberLower><#if socConcentration.lower.value?has_content>${socConcentration.lower.value?string["0.###############################"]}</#if></#assign>
    <#assign socNumberUpper><#if socConcentration.lower.value?has_content>${socConcentration.upper.value?string["0.###############################"]}</#if></#assign>

    <#if (socNumberLower?has_content && socNumberLower?number gt 0  || socNumberUpper?has_content && socNumberUpper?number gt 0)>
       <#return true>
    <#else>
      <#return false>
    </#if>

  <#elseif component.hasElement("TypicalConcentration")>
    <#assign socConcentration = component.TypicalConcentration />
    <#assign socNumberLower><#if socConcentration.lower.value?has_content>${socConcentration.lower.value}</#if></#assign>

    <#if socNumberLower?has_content && socNumberLower?number gt 0 >
       <#return true>
    <#else>
      <#return false>
    </#if>

  </#if>  
  </#assign>

  <#if soc>
  ${concentrationInformation}
  </#if>

  <#return true>

</#function>


<#function getFirstHistoryOnly _subject>

    <#local historyList = iuclid.getHistoryForDocumentKey(_subject.documentKey) />
	
        
        <#if !(historyList)?has_content>
            <#return [] />
        </#if>
        
        <#if historyList?has_content>		
            <#list historyList as history>	
                <#if !(history)?has_content>
                    <#return [] />	
                    <#else/>
                        <#return historyList[0] />					
                </#if>
            </#list>
        </#if>	
        
	<#return [] />			
</#function>

<#-------------------------------------->
<#-- macros for immediate data output -->
<#-------------------------------------->

<#macro frontPageCompositionNames compositions compositionType="">
<#if compositions?has_content>
    <#list compositions as composition>
        <#if compositionType=="product">
          <@com.text composition.GeneralInformation.Name />
        <#elseif compositionType=="family">
          <#if isFamilyComposition(composition) && composition.ProductSummaryComposition.ProductFamilyGroupName?has_content>
              <@com.text composition.ProductSummaryComposition.ProductFamilyGroupName />
          </#if>
        </#if>
    </#list>
</#if>
</#macro>

<#macro macroForPopulatingDossierHeader _dossierHeader>
<#assign authNumber = [] />
<#assign refAssetNumber = [] />
<#assign expiryDate = [] />
<#assign dateOfAuth = [] />


  <#if _dossierHeader?has_content>
      <#assign authNumber>
        <#if _dossierHeader.SpecificSubmissions.AuthorisationDetails.AuthorisationNumber?has_content>
        <@com.text _dossierHeader.SpecificSubmissions.AuthorisationDetails.AuthorisationNumber />
          <#elseif !(_dossierHeader.SpecificSubmissions.AuthorisationDetails.AuthorisationNumber?has_content)>
          <@com.text externalAuthorisationNumber />
        </#if>
      </#assign>

      <#if _dossierHeader.SpecificSubmissions.AuthorisationDetails.ReferenceNumber?has_content>
        <#assign refAssetNumber><@com.text _dossierHeader.SpecificSubmissions.AuthorisationDetails.ReferenceNumber/></#assign>
      </#if>

      <#if _dossierHeader.SpecificSubmissions.AuthorisationDetails.ExpiryDate?has_content>
        <#local valueExpiry=_dossierHeader.SpecificSubmissions.AuthorisationDetails.ExpiryDate?node_type/>
        <#if valueExpiry=="date">
          <#local dateFieldType = _dossierHeader.SpecificSubmissions.AuthorisationDetails.ExpiryDate?string[" dd/MM/yyyy "] />
          <#assign expiryDate>${dateFieldType}</#assign>
        </#if>
      </#if>

      <#if _dossierHeader.SpecificSubmissions.AuthorisationDetails.AuthorisationDate?has_content>
        <#local valueAuthorisation=_dossierHeader.SpecificSubmissions.AuthorisationDetails.AuthorisationDate?node_type/>
        <#if valueAuthorisation=="date">
          <#local dateFieldType = _dossierHeader.SpecificSubmissions.AuthorisationDetails.AuthorisationDate?string[" dd/MM/yyyy "] />
          <#assign dateOfAuth>${dateFieldType}</#assign>
        </#if>                
      </#if>
  </#if>
</#macro>

<#macro productTypes usesList id="" locale="en" page="">
<#compress>
  <#if usesList?has_content>
  <#assign phrases = productTypeFunction(usesList, "${id}")/>
    <#list phrases as phrase>
          ${phrase}
        <#if phrase_has_next><para></para></#if>
    </#list>
  </#if>
</#compress>
</#macro>

<#------------------------------------------>
<#-- alternative outputs to common_macros -->
<#------------------------------------------>

<#macro picklistMultipleWoutSemiColon picklistMultipleValue id="">
<#compress>
	<#if picklistMultipleValue?has_content && picklistMultipleValue?node_type=="picklist_multi" >
		<#list picklistMultipleValue as item>

      <#if item?has_content> 
          <#if id=="countryDesc">
            <#local localizedPhrase = iuclid.localizedPhraseDefinitionFor(item.code, "${languageLocale}") />
              <#if localizedPhrase.description?has_content>
                ${localizedPhrase.description}
              </#if>

          <#else>
              <@com.picklist item "${languageLocale}"/><#if item_has_next><?linebreak?></#if>          
          </#if>
      </#if>
		</#list>

  <#elseif picklistMultipleValue?has_content && picklistMultipleValue?node_type=="picklist_single" >
      <@com.picklist picklistMultipleValue "${languageLocale}"/>
	</#if>
</#compress>
</#macro>

<#------------------------------------------>
<#-- parameterised phrases function------ -->
<#------------------------------------------>

<#macro addWhiteSpaces amount>
    <#list 0..<amount as i>&#160;</#list>
</#macro>
